#include "orxonox_gui.h"
#include "orxonox_gui_video.h"
#include "orxonox_gui_audio.h"
int verbose = 1;

int main( int argc, char *argv[] )
  {
    GtkWidget *window;
    GtkWidget *vbox_main;
    GtkWidget *hbox_video_audio;
    GtkWidget *hbox_view_exec;
    struct settings *orxonox_settings;

    int option_count = 7; /* important: look that this is greater than options in 'struct settings' */

    /* Initialize all settings */
    
    orxonox_settings = malloc (option_count*sizeof (int));

    orxonox_gui_file_default (orxonox_settings);
    orxonox_gui_file_load ("~/.orxonox.conf", orxonox_settings);


    gtk_init (&argc, &argv);
    /* Main Window */
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title ( GTK_WINDOW (window), "orxonox");
    g_signal_connect (G_OBJECT (window), "delete_event", G_CALLBACK (gtk_main_quit), NULL);
    g_signal_connect (G_OBJECT (window), "destroy", G_CALLBACK (orxonox_gui_quit), orxonox_settings);
    gtk_container_set_border_width (GTK_CONTAINER (window), 5);
    
    /*  VBOX - MAIN */
    vbox_main = gtk_vbox_new (FALSE, 0);
    {
      hbox_video_audio = gtk_hbox_new (FALSE, 0);
      
      {
	gtk_box_pack_start(GTK_BOX(hbox_video_audio), orxonox_gui_video_frame(orxonox_settings), TRUE, TRUE, 0);	
	
	gtk_box_pack_start(GTK_BOX(hbox_video_audio), orxonox_gui_audio_frame(orxonox_settings), TRUE, TRUE, 0);	
      }
      gtk_box_pack_start (GTK_BOX (vbox_main), hbox_video_audio, TRUE, TRUE, 0);
      
      {
	hbox_view_exec = gtk_hbox_new ( FALSE,0);
	/*
	{
	  info ( hbox_view_exec );
	}
	*/
	{
	  gtk_box_pack_start(GTK_BOX(hbox_view_exec), orxonox_gui_exec_frame(orxonox_settings), TRUE, TRUE, 0);	

	}
	gtk_box_pack_start (GTK_BOX (vbox_main), hbox_view_exec, TRUE, TRUE, 0);
      } 
    }
    gtk_container_add (GTK_CONTAINER (window), vbox_main);
    
    gtk_widget_show_all  (window);

    gtk_main ();
    
    return(0);
  }
